diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/model/wimax-tlv.cc ns-3.40/src/wimax/model/wimax-tlv.cc
--- ns-3.39/src/wimax/model/wimax-tlv.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/src/wimax/model/wimax-tlv.cc	2023-09-27 13:30:37.930839800 -0700
@@ -239,8 +239,7 @@
 
 VectorTlvValue::~VectorTlvValue()
 {
-    for (std::vector<Tlv*>::const_iterator iter = m_tlvList->begin(); iter != m_tlvList->end();
-         ++iter)
+    for (auto iter = m_tlvList->begin(); iter != m_tlvList->end(); ++iter)
     {
         delete (*iter);
     }
@@ -252,8 +251,7 @@
 VectorTlvValue::GetSerializedSize() const
 {
     uint32_t size = 0;
-    for (std::vector<Tlv*>::const_iterator iter = m_tlvList->begin(); iter != m_tlvList->end();
-         ++iter)
+    for (auto iter = m_tlvList->begin(); iter != m_tlvList->end(); ++iter)
     {
         size += (*iter)->GetSerializedSize();
     }
@@ -263,8 +261,7 @@
 void
 VectorTlvValue::Serialize(Buffer::Iterator i) const
 {
-    for (std::vector<Tlv*>::const_iterator iter = m_tlvList->begin(); iter != m_tlvList->end();
-         ++iter)
+    for (auto iter = m_tlvList->begin(); iter != m_tlvList->end(); ++iter)
     {
         (*iter)->Serialize(i);
         i.Next((*iter)->GetSerializedSize());
@@ -297,8 +294,8 @@
 SfVectorTlvValue*
 SfVectorTlvValue::Copy() const
 {
-    SfVectorTlvValue* tmp = new SfVectorTlvValue();
-    for (std::vector<Tlv*>::const_iterator iter = Begin(); iter != End(); ++iter)
+    auto tmp = new SfVectorTlvValue();
+    for (auto iter = Begin(); iter != End(); ++iter)
     {
         tmp->Add(Tlv((*iter)->GetType(), (*iter)->GetLength(), *(*iter)->PeekValue()));
     }
@@ -528,7 +525,7 @@
 U8TlvValue*
 U8TlvValue::Copy() const
 {
-    U8TlvValue* tmp = new U8TlvValue(m_value);
+    auto tmp = new U8TlvValue(m_value);
     return tmp;
 }
 
@@ -581,7 +578,7 @@
 U16TlvValue*
 U16TlvValue::Copy() const
 {
-    U16TlvValue* tmp = new U16TlvValue(m_value);
+    auto tmp = new U16TlvValue(m_value);
     return tmp;
 }
 
@@ -634,7 +631,7 @@
 U32TlvValue*
 U32TlvValue::Copy() const
 {
-    U32TlvValue* tmp = new U32TlvValue(m_value);
+    auto tmp = new U32TlvValue(m_value);
     return tmp;
 }
 
@@ -693,8 +690,8 @@
 CsParamVectorTlvValue*
 CsParamVectorTlvValue::Copy() const
 {
-    CsParamVectorTlvValue* tmp = new CsParamVectorTlvValue();
-    for (std::vector<Tlv*>::const_iterator iter = Begin(); iter != End(); ++iter)
+    auto tmp = new CsParamVectorTlvValue();
+    for (auto iter = Begin(); iter != End(); ++iter)
     {
         tmp->Add(Tlv((*iter)->GetType(), (*iter)->GetLength(), *(*iter)->PeekValue()));
     }
@@ -710,8 +707,8 @@
 ClassificationRuleVectorTlvValue*
 ClassificationRuleVectorTlvValue::Copy() const
 {
-    ClassificationRuleVectorTlvValue* tmp = new ClassificationRuleVectorTlvValue();
-    for (std::vector<Tlv*>::const_iterator iter = Begin(); iter != End(); ++iter)
+    auto tmp = new ClassificationRuleVectorTlvValue();
+    for (auto iter = Begin(); iter != End(); ++iter)
     {
         tmp->Add(Tlv((*iter)->GetType(), (*iter)->GetLength(), *(*iter)->PeekValue()));
     }
@@ -888,9 +885,7 @@
 void
 PortRangeTlvValue::Serialize(Buffer::Iterator i) const
 {
-    for (std::vector<PortRange>::const_iterator iter = m_portRange->begin();
-         iter != m_portRange->end();
-         ++iter)
+    for (auto iter = m_portRange->begin(); iter != m_portRange->end(); ++iter)
     {
         i.WriteHtonU16((*iter).PortLow);
         i.WriteHtonU16((*iter).PortHigh);
@@ -935,10 +930,8 @@
 PortRangeTlvValue*
 PortRangeTlvValue::Copy() const
 {
-    PortRangeTlvValue* tmp = new PortRangeTlvValue();
-    for (std::vector<PortRange>::const_iterator iter = m_portRange->begin();
-         iter != m_portRange->end();
-         ++iter)
+    auto tmp = new PortRangeTlvValue();
+    for (auto iter = m_portRange->begin(); iter != m_portRange->end(); ++iter)
     {
         tmp->Add((*iter).PortLow, (*iter).PortHigh);
     }
@@ -971,8 +964,7 @@
 void
 ProtocolTlvValue::Serialize(Buffer::Iterator i) const
 {
-    for (std::vector<uint8_t>::const_iterator iter = m_protocol->begin(); iter != m_protocol->end();
-         ++iter)
+    for (auto iter = m_protocol->begin(); iter != m_protocol->end(); ++iter)
     {
         i.WriteU8((*iter));
     }
@@ -1011,9 +1003,8 @@
 ProtocolTlvValue*
 ProtocolTlvValue::Copy() const
 {
-    ProtocolTlvValue* tmp = new ProtocolTlvValue();
-    for (std::vector<uint8_t>::const_iterator iter = m_protocol->begin(); iter != m_protocol->end();
-         ++iter)
+    auto tmp = new ProtocolTlvValue();
+    for (auto iter = m_protocol->begin(); iter != m_protocol->end(); ++iter)
     {
         tmp->Add((*iter));
     }
@@ -1046,9 +1037,7 @@
 void
 Ipv4AddressTlvValue::Serialize(Buffer::Iterator i) const
 {
-    for (std::vector<Ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
-         iter != m_ipv4Addr->end();
-         ++iter)
+    for (auto iter = m_ipv4Addr->begin(); iter != m_ipv4Addr->end(); ++iter)
     {
         i.WriteHtonU32((*iter).Address.Get());
         i.WriteHtonU32((*iter).Mask.Get());
@@ -1090,10 +1079,8 @@
 Ipv4AddressTlvValue*
 Ipv4AddressTlvValue::Copy() const
 {
-    Ipv4AddressTlvValue* tmp = new Ipv4AddressTlvValue();
-    for (std::vector<Ipv4Addr>::const_iterator iter = m_ipv4Addr->begin();
-         iter != m_ipv4Addr->end();
-         ++iter)
+    auto tmp = new Ipv4AddressTlvValue();
+    for (auto iter = m_ipv4Addr->begin(); iter != m_ipv4Addr->end(); ++iter)
     {
         tmp->Add((*iter).Address, (*iter).Mask);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/test/wimax-fragmentation-test.cc ns-3.40/src/wimax/test/wimax-fragmentation-test.cc
--- ns-3.39/src/wimax/test/wimax-fragmentation-test.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/src/wimax/test/wimax-fragmentation-test.cc	2023-09-27 13:30:37.934840000 -0700
@@ -63,8 +63,8 @@
     GenericMacHeader hdr;
 
     Cid cid;
-    WimaxConnection* connectionTx = new WimaxConnection(cid, Cid::TRANSPORT);
-    WimaxConnection* connectionRx = new WimaxConnection(cid, Cid::TRANSPORT);
+    auto connectionTx = new WimaxConnection(cid, Cid::TRANSPORT);
+    auto connectionRx = new WimaxConnection(cid, Cid::TRANSPORT);
 
     // A Packet of 1000 bytes has been created.
     // It will be fragmentated into 4 fragments and then defragmentated into fullPacket.
@@ -127,9 +127,7 @@
             WimaxConnection::FragmentsQueue fragmentsQueue = connectionRx->GetFragmentsQueue();
 
             // DEFRAGMENTATION
-            for (std::list<Ptr<const Packet>>::const_iterator iter = fragmentsQueue.begin();
-                 iter != fragmentsQueue.end();
-                 ++iter)
+            for (auto iter = fragmentsQueue.begin(); iter != fragmentsQueue.end(); ++iter)
             {
                 // Create the whole Packet
                 fullPacket->AddAtEnd(*iter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/test/wimax-service-flow-test.cc ns-3.40/src/wimax/test/wimax-service-flow-test.cc
--- ns-3.39/src/wimax/test/wimax-service-flow-test.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/src/wimax/test/wimax-service-flow-test.cc	2023-09-27 13:30:37.934840000 -0700
@@ -98,7 +98,7 @@
     Ipv4InterfaceContainer BSinterface = address.Assign(bsDevs);
 
     // Create one UGS Downlink service flow between the ss and the bs
-    ServiceFlow* DlServiceFlowUgs = new ServiceFlow(ServiceFlow::SF_DIRECTION_DOWN);
+    auto DlServiceFlowUgs = new ServiceFlow(ServiceFlow::SF_DIRECTION_DOWN);
     IpcsClassifierRecord DlClassifierUgs(Ipv4Address("0.0.0.0"),
                                          Ipv4Mask("0.0.0.0"),
                                          Ipv4Address("0.0.0.0"),
@@ -121,7 +121,7 @@
     DlServiceFlowUgs->SetTrafficPriority(1);
 
     // Create one UGS Uplink service flow between the ss and the bs
-    ServiceFlow* UlServiceFlowUgs = new ServiceFlow(ServiceFlow::SF_DIRECTION_UP);
+    auto UlServiceFlowUgs = new ServiceFlow(ServiceFlow::SF_DIRECTION_UP);
     IpcsClassifierRecord UlClassifierUgs(Ipv4Address("0.0.0.0"),
                                          Ipv4Mask("0.0.0.0"),
                                          Ipv4Address("0.0.0.0"),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wimax/test/wimax-tlv-test.cc ns-3.40/src/wimax/test/wimax-tlv-test.cc
--- ns-3.39/src/wimax/test/wimax-tlv-test.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/src/wimax/test/wimax-tlv-test.cc	2023-09-27 13:30:37.934840000 -0700
@@ -89,10 +89,8 @@
     packet->RemoveHeader(tlvReceived);
     if (tlvReceived.GetType() == Tlv::UPLINK_SERVICE_FLOW)
     {
-        SfVectorTlvValue* sfVecValue = (SfVectorTlvValue*)tlvReceived.PeekValue();
-        for (std::vector<Tlv*>::const_iterator iter = sfVecValue->Begin();
-             iter != sfVecValue->End();
-             ++iter)
+        auto sfVecValue = (SfVectorTlvValue*)tlvReceived.PeekValue();
+        for (auto iter = sfVecValue->Begin(); iter != sfVecValue->End(); ++iter)
         {
             if ((*iter)->GetType() == SfVectorTlvValue::IPV4_CS_Parameters)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/test.py ns-3.40/test.py
--- ns-3.39/test.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/test.py	2023-09-27 13:30:37.934840000 -0700
@@ -15,31 +15,35 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-import os
-import sys
-import time
 import argparse
+import fnmatch
+import os
+import shutil
+import signal
 import subprocess
+import sys
 import threading
-import signal
-import xml.dom.minidom
-import shutil
-import fnmatch
+import time
+import xml.etree.ElementTree as ET
+
 
 from utils import get_list_from_file
 
+# Global variable
+args = None
+
 # imported from waflib Logs
 colors_lst={'USE':True,'BOLD':'\x1b[01;1m','RED':'\x1b[01;31m','GREEN':'\x1b[32m','YELLOW':'\x1b[33m','PINK':'\x1b[35m','BLUE':'\x1b[01;34m','CYAN':'\x1b[36m','GREY':'\x1b[37m','NORMAL':'\x1b[0m','cursor_on':'\x1b[?25h','cursor_off':'\x1b[?25l',}
 def get_color(cl):
     if colors_lst['USE']:
-        return colors_lst.get(cl,'')
-    return''
+        return colors_lst.get(cl, '')
+    return ''
 class color_dict(object):
-    def __getattr__(self,a):
+    def __getattr__(self, a):
         return get_color(a)
-    def __call__(self,a):
+    def __call__(self, a):
         return get_color(a)
-colors=color_dict()
+colors = color_dict()
 
 try:
     import queue
@@ -272,12 +276,11 @@
         node_to_text(child, f, 'Case')
 
 def translate_to_text(results_file, text_file):
-    text_file += '.txt'
+    text_file += ('.txt' if '.txt' not in text_file else '')
     print('Writing results to text file \"%s\"...' % text_file, end='')
-    import xml.etree.ElementTree as ET
     et = ET.parse(results_file)
 
-    with open(text_file, 'w') as f:
+    with open(text_file, 'w', encoding='utf-8') as f:
         for test in et.findall('Test'):
             node_to_text(test, f)
 
@@ -300,10 +303,10 @@
 # since it will probably grow over time.
 #
 def translate_to_html(results_file, html_file):
-    html_file += '.html'
+    html_file += ('.html' if '.html' not in html_file else '')
     print('Writing results to html file %s...' % html_file, end='')
 
-    with open(html_file, 'w') as f:
+    with open(html_file, 'w', encoding='utf-8') as f:
         f.write("<html>\n")
         f.write("<body>\n")
         f.write("<center><h1>ns-3 Test Results</h1></center>\n")
@@ -311,7 +314,6 @@
         #
         # Read and parse the whole results file.
         #
-        import xml.etree.ElementTree as ET
         et = ET.parse(results_file)
 
         #
@@ -392,7 +394,7 @@
                 f.write("<th>Failure Details</th>\n")
 
             #
-            # Now iterate through all of the test cases.
+            # Now iterate through all the test cases.
             #
             for case in suite.findall('Test'):
 
@@ -503,7 +505,7 @@
         f.write("<th>Details</th>\n")
 
         #
-        # Now iterate through all of the examples
+        # Now iterate through all the examples
         #
         for example in et.findall("Example"):
 
@@ -593,30 +595,28 @@
 #
 def read_ns3_config():
     lock_filename = ".lock-ns3_%s_build" % sys.platform
-    f = None
+
     try:
         # sys.platform reports linux2 for python2 and linux for python3
-        f = open(lock_filename, "rt")
+        with open(lock_filename, "rt", encoding="utf-8") as f:
+            for line in f:
+                if line.startswith("top_dir ="):
+                    key, val = line.split('=')
+                    top_dir = eval(val.strip())
+                if line.startswith("out_dir ="):
+                    key, val = line.split('=')
+                    out_dir = eval(val.strip())
+
     except FileNotFoundError:
         print('The .lock-ns3 file was not found.  You must configure before running test.py.', file=sys.stderr)
         sys.exit(2)
 
-    for line in f:
-        if line.startswith("top_dir ="):
-            key, val = line.split('=')
-            top_dir = eval(val.strip())
-        if line.startswith("out_dir ="):
-            key, val = line.split('=')
-            out_dir = eval(val.strip())
-
-    f.close()
-
     global NS3_BASEDIR
     NS3_BASEDIR = top_dir
     global NS3_BUILDDIR
     NS3_BUILDDIR = out_dir
 
-    with open(lock_filename) as f:
+    with open(lock_filename, encoding='utf-8') as f:
         for line in f.readlines():
             for item in interesting_config_items:
                 if line.startswith(item):
@@ -1026,7 +1026,7 @@
                     # know.  It will be something like "examples/udp/udp-echo" or
                     # "examples/wireless/mixed-wireless.py"
                     #
-                    (job.returncode, standard_out, standard_err, et) = run_job_synchronously(job.shell_command,
+                    (job.returncode, job.standard_out, job.standard_err, et) = run_job_synchronously(job.shell_command,
                         job.cwd, args.valgrind, job.is_pyexample, job.build_path)
                 else:
                     #
@@ -1038,7 +1038,7 @@
                         update_data = '--update-data'
                     else:
                         update_data = ''
-                    (job.returncode, standard_out, standard_err, et) = run_job_synchronously(job.shell_command +
+                    (job.returncode, job.standard_out, job.standard_err, et) = run_job_synchronously(job.shell_command +
                         " --xml --tempdir=%s --out=%s %s" % (job.tempdir, job.tmp_file_name, update_data),
                         job.cwd, args.valgrind, False)
 
@@ -1047,14 +1047,43 @@
                 if args.verbose:
                     print("returncode = %d" % job.returncode)
                     print("---------- begin standard out ----------")
-                    print(standard_out)
+                    print(job.standard_out)
                     print("---------- begin standard err ----------")
-                    print(standard_err)
+                    print(job.standard_err)
                     print("---------- end standard err ----------")
 
                 self.output_queue.put(job)
 
 #
+# This function loads the list of previously successful or skipped examples and test suites.
+#
+def load_previously_successful_tests():
+    import glob
+    previously_run_tests_to_skip = {"test": [], "example": []}
+    previous_results = glob.glob(f"{TMP_OUTPUT_DIR}/*-results.xml")
+    if not previous_results:
+        print("No previous runs to rerun")
+        exit(-1)
+    latest_result_file = list(sorted(previous_results, key=lambda x: os.path.basename(x), reverse=True))[0]
+
+    try:
+        previous_run_results = ET.parse(latest_result_file)
+    except ET.ParseError:
+        print(f"Failed to parse XML {latest_result_file}")
+        exit(-1)
+
+    for test_type in ["Test", "Example"]:
+        if previous_run_results.find(test_type):
+            temp = list(map(lambda x: (x.find('Name').text, x.find('Result').text),
+                            previous_run_results.findall(test_type)
+                            )
+                        )
+            temp = list(filter(lambda x: x[1] in ['PASS', 'SKIP'], temp))
+            temp = [x[0] for x in temp]
+            previously_run_tests_to_skip[test_type.lower()] = temp
+    return previously_run_tests_to_skip
+
+#
 # This is the main function that does the work of interacting with the
 # test-runner itself.
 #
@@ -1248,13 +1277,13 @@
             examples_sorted.sort()
         if ENABLE_PYTHON_BINDINGS:
             python_examples_sorted = []
-            for (x,y) in python_tests:
+            for (x, y) in python_tests:
                 if y == 'True':
                     python_examples_sorted.append(x)
             python_examples_sorted.sort()
             examples_sorted.extend(python_examples_sorted)
         for item in examples_sorted:
-                print("example     ", item)
+            print("example     ", item)
         print()
 
     if args.kinds or args.list:
@@ -1286,17 +1315,26 @@
     if not os.path.exists(TMP_OUTPUT_DIR):
         os.makedirs(TMP_OUTPUT_DIR)
 
-    testpy_output_dir = os.path.join(TMP_OUTPUT_DIR, date_and_time);
+    testpy_output_dir = os.path.join(TMP_OUTPUT_DIR, date_and_time)
 
     if not os.path.exists(testpy_output_dir):
         os.makedirs(testpy_output_dir)
 
     #
+    # Load results from the latest results.xml, then use the list of
+    # failed tests to filter out (SKIP) successful tests
+    #
+    previously_run_tests_to_skip = {"test": [], "example": []}
+    if args.rerun_failed:
+        previously_run_tests_to_skip = load_previously_successful_tests()
+
+    #
     # Create the main output file and start filling it with XML.  We need to
     # do this since the tests will just append individual results to this file.
+    # The file is created outside the directory that gets automatically deleted.
     #
-    xml_results_file = os.path.join(testpy_output_dir, "results.xml")
-    with open(xml_results_file, 'w') as f:
+    xml_results_file = os.path.join(TMP_OUTPUT_DIR, f"{date_and_time}-results.xml")
+    with open(xml_results_file, 'w', encoding='utf-8') as f:
         f.write('<?xml version="1.0"?>\n')
         f.write('<Results>\n')
 
@@ -1333,7 +1371,8 @@
         if isinstance(suites, bytes):
             suites = suites.decode()
 
-        suites_found = fnmatch.filter(suites.split('\n'), args.suite)
+        suites = suites.replace("\r\n", "\n")
+        suites_found = fnmatch.filter(suites.split("\n"), args.suite)
 
         if not suites_found:
             print('The test suite was not run because an unknown test suite name was requested.', file=sys.stderr)
@@ -1392,7 +1431,7 @@
     output_queue = queue.Queue(0)
 
     jobs = 0
-    threads=[]
+    threads = []
 
     #
     # In Python 2.6 you can just use multiprocessing module, but we don't want
@@ -1401,7 +1440,7 @@
     processors = 1
 
     if sys.platform != "win32":
-        if 'SC_NPROCESSORS_ONLN'in os.sysconf_names:
+        if 'SC_NPROCESSORS_ONLN' in os.sysconf_names:
             processors = os.sysconf('SC_NPROCESSORS_ONLN')
         else:
             proc = subprocess.Popen("sysctl -n hw.ncpu", shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
@@ -1443,7 +1482,7 @@
     # Dispatching will run with unlimited speed and the worker threads will
     # execute as fast as possible from the queue.
     #
-    # Note that we actually dispatch tests to be skipped, so all of the
+    # Note that we actually dispatch tests to be skipped, so all the
     # PASS, FAIL, CRASH and SKIP processing is done in the same place.
     #
     for test in suite_list:
@@ -1475,6 +1514,10 @@
                 job.set_is_skip(True)
                 job.set_skip_reason("crashes valgrind")
 
+            if args.rerun_failed and test in previously_run_tests_to_skip["test"]:
+                job.is_skip = True
+                job.set_skip_reason("didn't fail in the previous run")
+
             if args.verbose:
                 print("Queue %s" % test)
 
@@ -1541,6 +1584,10 @@
                                 job.set_is_skip(True)
                                 job.set_skip_reason("skip in valgrind runs")
 
+                            if args.rerun_failed and name in previously_run_tests_to_skip["example"]:
+                                job.is_skip = True
+                                job.set_skip_reason("didn't fail in the previous run")
+
                             if args.verbose:
                                 print("Queue %s" % test)
 
@@ -1555,7 +1602,7 @@
 
         key_list = []
         for key in ns3_runnable_programs_dictionary:
-            key_list.append (key)
+            key_list.append(key)
         example_name_key_list = fnmatch.filter(key_list, example_name)
 
         if len(example_name_key_list) == 0:
@@ -1716,6 +1763,7 @@
     crashed_testnames = []
     valgrind_errors = 0
     valgrind_testnames = []
+    failed_jobs = []
     for i in range(jobs):
         job = output_queue.get()
         if job.is_break:
@@ -1732,10 +1780,12 @@
             skipped_tests = skipped_tests + 1
             skipped_testnames.append(job.display_name + (" (%s)" % job.skip_reason))
         else:
+            failed_jobs.append(job)
             if job.returncode == 0:
                 status = "PASS"
                 status_print = colors.GREEN + status + colors.NORMAL
                 passed_tests = passed_tests + 1
+                failed_jobs.pop()
             elif job.returncode == 1:
                 failed_tests = failed_tests + 1
                 failed_testnames.append(job.display_name)
@@ -1752,7 +1802,7 @@
                 status = "CRASH"
                 status_print = colors.PINK + status + colors.NORMAL
 
-        print("[%d/%d]" % (passed_tests + failed_tests + skipped_tests + crashed_tests, total_tests), end=' ')
+        print("[%d/%d]" % (i, total_tests), end=' ')
         if args.duration or args.constrain == "performance":
             print("%s (%.3f): %s %s" % (status_print, job.elapsed_time, kind, job.display_name))
         else:
@@ -1768,7 +1818,7 @@
             # XXX We could add some timing information to the examples, i.e. run
             # them through time and print the results here.
             #
-            with open(xml_results_file, 'a') as f:
+            with open(xml_results_file, 'a', encoding='utf-8') as f:
                 f.write('<Example>\n')
                 example_name = "  <Name>%s</Name>\n" % job.display_name
                 f.write(example_name)
@@ -1833,18 +1883,27 @@
             # followed by a VALGR failing test suite of the same name.
             #
             if job.is_skip:
-                with open(xml_results_file, 'a') as f:
+                with open(xml_results_file, 'a', encoding='utf-8') as f:
                     f.write("<Test>\n")
                     f.write("  <Name>%s</Name>\n" % job.display_name)
                     f.write('  <Result>SKIP</Result>\n')
                     f.write("  <Reason>%s</Reason>\n" % job.skip_reason)
                     f.write("</Test>\n")
             else:
+                failed_jobs.append(job)
                 if job.returncode == 0 or job.returncode == 1 or job.returncode == 2:
-                    with open(xml_results_file, 'a') as f_to, open(job.tmp_file_name) as f_from:
-                        f_to.write(f_from.read())
+                    with open(xml_results_file, 'a', encoding='utf-8') as f_to, open(job.tmp_file_name, encoding='utf-8') as f_from:
+                        contents = f_from.read()
+                        if status == "VALGR":
+                            pre = contents.find("<Result>") + len("<Result>")
+                            post = contents.find("</Result>")
+                            contents = contents[:pre] + "VALGR" + contents[post:]
+                        f_to.write(contents)
+                        et = ET.parse(job.tmp_file_name)
+                        if et.find("Result").text in ["PASS", "SKIP"]:
+                            failed_jobs.pop()
                 else:
-                    with open(xml_results_file, 'a') as f:
+                    with open(xml_results_file, 'a', encoding='utf-8') as f:
                         f.write("<Test>\n")
                         f.write("  <Name>%s</Name>\n" % job.display_name)
                         f.write('  <Result>CRASH</Result>\n')
@@ -1864,7 +1923,7 @@
     # individual pieces.  So, we need to finish off and close out the XML
     # document
     #
-    with open(xml_results_file, 'a') as f:
+    with open(xml_results_file, 'a', encoding='utf-8') as f:
         f.write('</Results>\n')
 
     #
@@ -1887,8 +1946,18 @@
     if valgrind_testnames:
         valgrind_testnames.sort()
         print('List of VALGR failures:\n    %s' % '\n    '.join(map(str, valgrind_testnames)))
+
+    if failed_jobs and args.verbose_failed:
+        for job in failed_jobs:
+            if job.standard_out or job.standard_err:
+                job_type = 'example' if (job.is_example or job.is_pyexample) else 'test suite'
+                print(f"===================== Begin of {job_type} '{job.display_name}' stdout =====================")
+                print(job.standard_out)
+                print(f"===================== Begin of {job_type} '{job.display_name}' stderr =====================")
+                print(job.standard_err)
+                print(f"===================== End of {job_type} '{job.display_name}' ==============================")
     #
-    # The last things to do are to translate the XML results file to "human
+    # The last things to do are to translate the XML results file to "human-
     # readable form" if the user asked for it (or make an XML file somewhere)
     #
     if len(args.html) + len(args.text) + len(args.xml):
@@ -1901,7 +1970,7 @@
         translate_to_text(xml_results_file, args.text)
 
     if len(args.xml):
-        xml_file = args.xml + '.xml'
+        xml_file = args.xml + ('.xml' if ".xml" not in args.xml else '')
         print('Writing results to xml file %s...' % xml_file, end='')
         shutil.copyfile(xml_results_file, xml_file)
         print('done.')
@@ -1996,6 +2065,9 @@
     parser.add_argument("-v", "--verbose", action="store_true", default=False,
                         help="print progress and informational messages")
 
+    parser.add_argument("--verbose-failed", action="store_true", default=False,
+                        help="print progress and informational messages for failed jobs")
+
     parser.add_argument("-w", "--web", "--html", action="store", type=str, dest="html", default="",
                         metavar="HTML-FILE",
                         help="write detailed test results into HTML-FILE.html")
@@ -2010,12 +2082,15 @@
     parser.add_argument("--jobs", action="store", type=int, dest="process_limit", default=0,
                         help="limit number of worker threads")
 
+    parser.add_argument("--rerun-failed", action="store_true", dest="rerun_failed", default=False,
+                        help="rerun failed tests")
+
     global args
     args = parser.parse_args()
     signal.signal(signal.SIGINT, sigint_hook)
 
     # From waf/waflib/Options.py
-    envcolor=os.environ.get('NOCOLOR','') and 'no' or 'auto' or 'yes'
+    envcolor = os.environ.get('NOCOLOR', '') and 'no' or 'auto' or 'yes'
 
     if args.nocolor or envcolor == 'no':
         colors_lst['USE'] = False
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/bench-scheduler.cc ns-3.40/utils/bench-scheduler.cc
--- ns-3.39/utils/bench-scheduler.cc	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils/bench-scheduler.cc	2023-09-27 13:30:37.934840000 -0700
@@ -432,7 +432,7 @@
         {
             if (*input >> value)
             {
-                uint64_t ns = (uint64_t)(value * 1000000000);
+                auto ns = (uint64_t)(value * 1000000000);
                 nsValues.push_back(ns);
             }
             else
